// sysexInterface.cpp : Implementation of CsysexInterface
#include "stdafx.h"
#include "Sysexserver.h"
#include "sysexInterface.h"
#include "sysex.h"

/////////////////////////////////////////////////////////////////////////////
// CsysexInterface

STDMETHODIMP CsysexInterface::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IsysexInterface
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

void DoFileOpen(LPCTSTR pszFile)
{
	HANDLE hFile;
	hFile=CreateFile(pszFile,
						  GENERIC_READ|GENERIC_WRITE,
						  0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

	
	if(hFile==INVALID_HANDLE_VALUE)
	{
		CONSTRUCT_SYSEX(ex);
		ex.SetError(GetLastError());
		ex.SetDescription(pszFile);
		throw ex;
	}

	CloseHandle(hFile);
}

STDMETHODIMP CsysexInterface::OpenFile(BSTR bstrFile, VARIANT_BOOL *pbSuccess)
{
	_bstr_t bstrTemp(bstrFile,false);

	*pbSuccess=false;

	try
	{
		DoFileOpen(bstrTemp);

		*pbSuccess=true;
	}
	catch(sys_EX& ex)
	{
		return ex.raise_com_error(IID_IsysexInterface);
	}

	return S_OK;
}
